
package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractBenutzerEinsatzortEdit {

  @Inject
  protected BenutzerEinsatzortDAO dao;

  @Inject
  protected BenutzerEinsatzortExtendedDAO extendedDao;

  public void delete(BenutzerEinsatzort entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(BenutzerEinsatzort entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(BenutzerEinsatzort entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected BenutzerEinsatzort getAttachedEntity(BenutzerEinsatzort entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected BenutzerEinsatzort getAttachedAndRefreshedEntity(BenutzerEinsatzort entity) {
    return dao.refresh(entity);
  }
}
